Bullet = Object:extend()

function Bullet:new(x, y, width, height, speed, damage, movetype, name)
    self.x = x
    self.y = y
    self.width = width
    self.height = height
    self.speed = speed
    self.damage = damage
    self.movetype = movetype
    self.name = name
    
    
    self.sprite = love.graphics.newImage('halloween/hallowicons_2.png')
    self.grid = anim8.newGrid(32, 32, self.sprite:getWidth(), self.sprite:getHeight())
    self.animations = {}
    self.animations.pumpkin = anim8.newAnimation(self.grid(2, 1), 0.1)
    
    self.anim = self.animations.pumpkin
    
    self.collider = world:newRectangleCollider(self.x, self.y, self.width, self.height)
    self.collider:setCollisionClass('Bullet')
    self.collider:setObject(self)
end

function Bullet:update(dt)
    self.anim:update(dt)
    local vX = 0
    local vY = 0
    if self.movetype == "toright" then
        vX = 1
    end
    if self.movetype == "toleft" then
        vX = -1
    end
    if self.movetype == "toup" then
        vY = -1
    end
    if self.movetype == "todown" then
        vY = 1
    end
    if self.collider ~= nil then
        self.collider:setLinearVelocity(vX * self.speed, vY * self.speed)
    end
end

function Bullet:boom()
    for k, v in ipairs(listOfBullets) do
	      if v == self then
            self.collider:destroy()
            table.remove(listOfBullets, k) 
            break 
        end
    end
end

function Bullet:draw()
    self.x = self.collider:getX()
    self.y = self.collider:getY()
    self.anim:draw(self.sprite, self.x, self.y, nil, 1, 1, 16, 16)
end